------------------------------------------------------------------------------
--                                                                          --
--                                AdaWebPack                                --
--                                                                          --
------------------------------------------------------------------------------
--  Copyright © 2020-2021, Vadim Godunko                                    --
--  All rights reserved.                                                    --
--                                                                          --
--  Redistribution and use in source and binary forms, with or without      --
--  modification, are permitted provided that the following conditions are  --
--  met:                                                                    --
--                                                                          --
--  1. Redistributions of source code must retain the above copyright       --
--     notice, this list of conditions and the following disclaimer.        --
--                                                                          --
--  2. Redistributions in binary form must reproduce the above copyright    --
--     notice, this list of conditions and the following disclaimer in the  --
--     documentation and/or other materials provided with the distribution. --
--                                                                          --
--  3. Neither the name of the copyright holder nor the names of its        --
--     contributors may be used to endorse or promote products derived      --
--     from this software without specific prior written permission.        --
--                                                                          --
--  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS     --
--  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT       --
--  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR   --
--  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT    --
--  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,  --
--  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT        --
--  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,   --
--  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY   --
--  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT     --
--  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE   --
--  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.    --
------------------------------------------------------------------------------

with Interfaces;

with WASM.Objects;

package body Web.UI_Events.Mouse_Events is

   -------------
   -- Buttons --
   -------------

   function Buttons (Self : Mouse_Event) return DOM_Unsigned_Short is
      function Imported
       (Identifier : WASM.Objects.Object_Identifier)
          return Interfaces.Unsigned_16
            with Import     => True,
                 Convention => C,
                 Link_Name  =>
                   "__adawebpack__uievents__MouseEvent__buttons_getter";

   begin
      return DOM_Unsigned_Short (Imported (Self.Identifier));
   end Buttons;

   --------------
   -- Offset_X --
   --------------

   function Offset_X (Self : Mouse_Event) return DOM_Double is
      function Imported
       (Identifier : WASM.Objects.Object_Identifier) return DOM_Double
          with Import     => True,
               Convention => C,
               Link_Name  =>
                 "__adawebpack__uievents__MouseEvent__offsetX_getter";

   begin
      return Imported (Self.Identifier);
   end Offset_X;

   --------------
   -- Offset_Y --
   --------------

   function Offset_Y (Self : Mouse_Event) return DOM_Double is
      function Imported
       (Identifier : WASM.Objects.Object_Identifier) return DOM_Double
          with Import     => True,
               Convention => C,
               Link_Name  =>
                 "__adawebpack__uievents__MouseEvent__offsetY_getter";

   begin
      return Imported (Self.Identifier);
   end Offset_Y;

   ------------
   -- Page_X --
   ------------

   function Page_X (Self : Mouse_Event) return DOM_Double is
      function Imported
       (Identifier : WASM.Objects.Object_Identifier) return DOM_Double
          with Import     => True,
               Convention => C,
               Link_Name  =>
                 "__adawebpack__uievents__MouseEvent__pageX_getter";

   begin
      return Imported (Self.Identifier);
   end Page_X;

   ------------
   -- Page_Y --
   ------------

   function Page_Y (Self : Mouse_Event) return DOM_Double is
      function Imported
       (Identifier : WASM.Objects.Object_Identifier) return DOM_Double
          with Import     => True,
               Convention => C,
               Link_Name  =>
                 "__adawebpack__uievents__MouseEvent__pageY_getter";

   begin
      return Imported (Self.Identifier);
   end Page_Y;

end Web.UI_Events.Mouse_Events;
